VERSION 5.00
Object = "{6B7E6392-850A-101B-AFC0-4210102A8DA7}#1.3#0"; "COMCTL32.OCX"
Begin VB.Form DragNodeForm 
   Caption         =   "DragNode"
   ClientHeight    =   3285
   ClientLeft      =   1785
   ClientTop       =   1740
   ClientWidth     =   3735
   LinkTopic       =   "Form10"
   ScaleHeight     =   3285
   ScaleWidth      =   3735
   Begin ComctlLib.TreeView trvCompany 
      DragIcon        =   "DragNode.frx":0000
      Height          =   3255
      Left            =   0
      TabIndex        =   0
      Top             =   0
      Width           =   2295
      _ExtentX        =   4048
      _ExtentY        =   5741
      _Version        =   327682
      LineStyle       =   1
      Style           =   7
      Appearance      =   1
   End
   Begin VB.Image IconImage 
      Height          =   480
      Index           =   3
      Left            =   3000
      Picture         =   "DragNode.frx":0152
      Top             =   2760
      Width           =   480
   End
   Begin VB.Image IconImage 
      Height          =   480
      Index           =   2
      Left            =   3000
      Picture         =   "DragNode.frx":02A4
      Top             =   2280
      Width           =   480
   End
   Begin VB.Image IconImage 
      Height          =   480
      Index           =   1
      Left            =   3000
      Picture         =   "DragNode.frx":03F6
      Top             =   1800
      Width           =   480
   End
   Begin VB.Image TreeImage 
      Height          =   240
      Index           =   6
      Left            =   3360
      Picture         =   "DragNode.frx":0548
      Top             =   1440
      Width           =   240
   End
   Begin VB.Image TreeImage 
      Height          =   240
      Index           =   5
      Left            =   3360
      Picture         =   "DragNode.frx":064A
      Top             =   1080
      Width           =   240
   End
   Begin VB.Image TreeImage 
      Height          =   240
      Index           =   4
      Left            =   3360
      Picture         =   "DragNode.frx":098C
      Top             =   720
      Width           =   240
   End
   Begin VB.Image TreeImage 
      Height          =   240
      Index           =   3
      Left            =   3000
      Picture         =   "DragNode.frx":0CCE
      Top             =   1440
      Width           =   240
   End
   Begin VB.Image TreeImage 
      Height          =   240
      Index           =   2
      Left            =   3000
      Picture         =   "DragNode.frx":0DD0
      Top             =   1080
      Width           =   240
   End
   Begin VB.Image TreeImage 
      Height          =   240
      Index           =   1
      Left            =   3000
      Picture         =   "DragNode.frx":1112
      Top             =   720
      Width           =   240
   End
   Begin ComctlLib.ImageList imlNodes 
      Left            =   3000
      Top             =   0
      _ExtentX        =   1005
      _ExtentY        =   1005
      BackColor       =   -2147483643
      MaskColor       =   12632256
      _Version        =   327682
   End
   Begin VB.Menu mnuNodes 
      Caption         =   "&Nodes"
      Begin VB.Menu mnuAddFactory 
         Caption         =   "Add &Factory"
      End
      Begin VB.Menu mnuAddGroup 
         Caption         =   "Add &Group"
      End
      Begin VB.Menu mnuAddPerson 
         Caption         =   "Add &Person"
      End
   End
End
Attribute VB_Name = "DragNodeForm"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'From the book Rod Stephens "Ready-to-run Visual Basic Code Library", Wiley Press
'An excellent and handy book of examples

Option Explicit

' Data item types.
Private Enum ObjectType
    otNone = 0
    otFactory = 1
    otGroup = 2
    otPerson = 3
    otFactory2 = 4
    otGroup2 = 5
    otPerson2 = 6
End Enum

' Node drag and drop variables.
Private SourceNode As Object
Private SourceType As ObjectType
Private TargetNode As Object
' The user is dropping. See if the drop is valid.
Private Sub trvCompany_DragDrop(Source As Control, x As Single, y As Single)
    If Not (trvCompany.DropHighlight Is Nothing) Then
        ' It's a valid drop. Set source node's
        ' parent to be the target node.
        Set SourceNode.Parent = trvCompany.DropHighlight
        Set trvCompany.DropHighlight = Nothing
    End If

    Set SourceNode = Nothing
    SourceType = otNone
End Sub

' Save the node pressed so we can drag it later.
Private Sub trvCompany_MouseDown(Button As Integer, Shift As Integer, x As Single, y As Single)
    Set SourceNode = trvCompany.HitTest(x, y)
End Sub

' The mouse is being dragged over the control.
' Highlight the appropriate node.
Private Sub trvCompany_DragOver(Source As Control, x As Single, y As Single, State As Integer)
Dim target As Node
Dim highlight As Boolean

    ' See what node we're above.
    Set target = trvCompany.HitTest(x, y)
    
    ' If it's the same as last time, do nothing.
    If target Is TargetNode Then Exit Sub
    Set TargetNode = target
    
    highlight = False
    If Not (TargetNode Is Nothing) Then
        ' See what kind of node were above.
        If NodeType(TargetNode) + 1 = SourceType Then _
            highlight = True
    End If
    
    If highlight Then
        Set trvCompany.DropHighlight = TargetNode
    Else
        Set trvCompany.DropHighlight = Nothing
    End If
End Sub

' Start a drag if one is not in progress.
Private Sub trvCompany_MouseMove(Button As Integer, Shift As Integer, x As Single, y As Single)
    If Button = vbLeftButton Then
        ' Start a new drag. Note that we do not get
        ' other MouseMove events while the drag is
        ' in progress.

        ' See what node we are dragging.
        SourceType = NodeType(SourceNode)

        ' Select this node. When no node is highlighted,
        ' this node will be displayed as selected. That
        ' shows where it will land if dropped.
        Set trvCompany.SelectedItem = SourceNode

        ' Set the drag icon for this source.
        trvCompany.DragIcon = IconImage(SourceType)
        trvCompany.Drag vbBeginDrag
    End If
End Sub
' Return the node's object type.
Private Function NodeType(test_node As Node) As ObjectType
    If test_node Is Nothing Then
        NodeType = otNone
    Else
        Select Case Left$(test_node.Key, 1)
            Case "f"
                NodeType = otFactory
            Case "g"
                NodeType = otGroup
            Case "p"
                NodeType = otPerson
        End Select
    End If
End Function
' Prepare the ImageList and TreeView controls.
Private Sub Form_Load()
Dim i As Integer
Dim factory As Node
Dim group As Node
Dim person As Node

    ' Load pictures into the ImageList.
    For i = 1 To 6
        imlNodes.ListImages.Add , , TreeImage(i).Picture
    Next i
    
    ' Attach the TreeView to the ImageList.
    trvCompany.ImageList = imlNodes
    
    ' Create some nodes.
    Set factory = trvCompany.Nodes.Add(, , "f R & D", "R & D", otFactory, otFactory2)
    Set group = trvCompany.Nodes.Add(factory, tvwChild, "g Engineering", "Engineering", otGroup, otGroup2)
    Set person = trvCompany.Nodes.Add(group, tvwChild, "p Cameron, Charlie", "Cameron, Charlie", otPerson, otPerson2)
    Set person = trvCompany.Nodes.Add(group, tvwChild, "p Davos, Debbie", "Davos, Debbie", otPerson, otPerson2)
    person.EnsureVisible
    Set group = trvCompany.Nodes.Add(factory, tvwChild, "g Test", "Test", otGroup, otGroup2)
    Set person = trvCompany.Nodes.Add(group, tvwChild, "p Able, Andy", "Andy, Able", otPerson, otPerson2)
    Set person = trvCompany.Nodes.Add(group, tvwChild, "p Baker, Betty", "Baker, Betty", otPerson, otPerson2)
    person.EnsureVisible
    
    Set factory = trvCompany.Nodes.Add(, , "f Sales & Support", "Sales & Support", otFactory, otFactory2)
    Set group = trvCompany.Nodes.Add(factory, tvwChild, "g Showroom Sales", "Showroom Sales", otGroup, otGroup2)
    Set person = trvCompany.Nodes.Add(group, tvwChild, "p Gaines, Gina", "Gaines, Gina", otPerson, otPerson2)
    person.EnsureVisible
    Set group = trvCompany.Nodes.Add(factory, tvwChild, "g Field Service", "Field Service", otGroup, otGroup2)
    Set person = trvCompany.Nodes.Add(group, tvwChild, "p Helms, Harry", "Helms, Harry", otPerson, otPerson2)
    Set person = trvCompany.Nodes.Add(group, tvwChild, "p Ives, Irma", "Ives, Irma", otPerson, otPerson2)
    Set person = trvCompany.Nodes.Add(group, tvwChild, "p Jackson, Josh", "Jackson, Josh", otPerson, otPerson2)
    person.EnsureVisible
    Set group = trvCompany.Nodes.Add(factory, tvwChild, "g Customer Support", "Customer Support", otGroup, otGroup2)
    Set person = trvCompany.Nodes.Add(group, tvwChild, "p Klug, Karl", "Klug, Karl", otPerson, otPerson2)
    Set person = trvCompany.Nodes.Add(group, tvwChild, "p Landau, Linda", "Landau, Linda", otPerson, otPerson2)
    person.EnsureVisible
End Sub
' Make the TreeView as large as possible.
Private Sub Form_Resize()
    trvCompany.Move 0, 0, ScaleWidth, ScaleHeight
End Sub

' Add a new factory.
Private Sub mnuAddFactory_Click()
Dim name As String
Dim factory As Node

    name = InputBox("Factory Name", "New Factory", "")
    If name = "" Then Exit Sub

    Set factory = trvCompany.Nodes.Add(, , "f " & name, name, otFactory, otFactory2)
    factory.EnsureVisible
End Sub

' Add a new group.
Private Sub mnuAddGroup_Click()
Dim name As String
Dim factory As Node
Dim group As Node

    name = InputBox("Group Name", "New Group", "")
    If name = "" Then Exit Sub
    
    ' Find the factory that should hold the new group.
    Set factory = trvCompany.SelectedItem
    If NodeType(factory) = otPerson Then _
        Set factory = factory.Parent
    If NodeType(factory) = otGroup Then _
        Set factory = factory.Parent

    Set group = trvCompany.Nodes.Add(factory, tvwChild, "g " & name, name, otGroup, otGroup2)
    group.EnsureVisible
End Sub

' The user is opening the Nodes menu. See which
' menu items should be enabled.
Private Sub mnuNodes_Click()
Dim selected_node As Node
Dim selected_type As ObjectType

    Set selected_node = trvCompany.SelectedItem
    If selected_node Is Nothing Then
        selected_type = otNone
    Else
        selected_type = NodeType(selected_node)
    End If

    ' You can always add a factory.
    
    ' You can add a group if a factory, person, or
    ' group is selected.
    mnuAddGroup.Enabled = (selected_type <> otNone)
    
    ' You can add a person if a group or person
    ' is selected.
    mnuAddPerson.Enabled = (selected_type = otPerson) _
        Or (selected_type = otGroup)
End Sub
' Add a new person.
Private Sub mnuAddPerson_Click()
Dim name As String
Dim group As Node
Dim person As Node

    name = InputBox("Person Name", "New Person", "")
    If name = "" Then Exit Sub
    
    ' Find the group that should hold the new person.
    Set group = trvCompany.SelectedItem
    If NodeType(group) = otPerson Then _
        Set group = group.Parent

    Set person = trvCompany.Nodes.Add(group, tvwChild, "p " & name, name, otPerson, otPerson2)
    person.EnsureVisible
End Sub
